Attribute VB_Name = "modTrackMouseEvent"
Option Explicit

' *** Constants
' *** SetWindowLong
Public Const GWL_WNDPROC = (-4)

' *** Window Messages
Public Const TME_CANCEL = &H80000000
Public Const TME_HOVER = &H1&
Public Const TME_LEAVE = &H2&
Public Const TME_NONCLIENT = &H10&
Public Const TME_QUERY = &H40000000
Public Const WM_MOUSELEAVE = &H2A3&
Public Const WM_PAINT = &HF

' *** Variables
' *** lpPrevWindowProc
Public lpPrevWindowProc As Long

' *** hWndHoverControl
Public hWndHoverControl As Long

' *** Types
' *** TrackMouseEventType
Public Type TRACKMOUSEEVENTTYPE
    cbSize As Long
    dwFlags As Long
    hwndTrack As Long
    dwHoverTime As Long
End Type

' *** Functions
' *** Window Functions
Public Declare Function CallWindowProc Lib "user32" _
                        Alias "CallWindowProcA" ( _
                        ByVal lpPrevWndFunc As Long, _
                        ByVal hwnd As Long, _
                        ByVal Msg As Long, _
                        ByVal wParam As Long, _
                        ByVal lParam As Long) As Long
                        
Public Declare Function DefWindowProc Lib "user32" _
                        Alias "DefWindowProcA" ( _
                        ByVal hwnd As Long, _
                        ByVal wMsg As Long, _
                        ByVal wParam As Long, _
                        ByVal lParam As Long) As Long
                        
Public Declare Function SendMessage Lib "user32" _
                        Alias "SendMessageA" ( _
                        ByVal hwnd As Long, _
                        ByVal wMsg As Long, _
                        ByVal wParam As Long, _
                        lParam As Any) As Long
                        
Public Declare Function SetWindowLong Lib "user32" _
                        Alias "SetWindowLongA" ( _
                        ByVal hwnd As Long, _
                        ByVal nIndex As Long, _
                        ByVal dwNewLong As Long) As Long
                        
Public Declare Function TrackMouseEvent Lib "user32" ( _
                        lpEventTrack As TRACKMOUSEEVENTTYPE) As Long
                        
' ======================================================================================
' --------------------------------- WindowProc -----------------------------------------
' ======================================================================================
Public Function WindowProc(ByVal hwnd As Long, ByVal uMsg As Long, ByVal wParam As Long, _
    ByVal lParam As Long) As Long
    
    ' *** Ignore Errors
    On Error Resume Next
    
    ' *** Select uMsg
    Select Case uMsg
    
    ' *** MouseLeave
    Case Is = WM_MOUSELEAVE
    
        ' *** Set hWndHoverControl
        hWndHoverControl = 0
        
        ' *** Set UMsg
        uMsg = WM_PAINT
        
        ' *** CallWindowProc
        WindowProc = CallWindowProc(lpPrevWindowProc, hwnd, uMsg, wParam, lParam)
        
        ' *** SetWindowLong
        If SetWindowLong(hwnd, GWL_WNDPROC, lpPrevWindowProc) <> 0 Then
        
            ' *** Set lpPrevWWindowProc
            lpPrevWindowProc = 0
        End If
        
    ' *** Other
    Case Else
    
        ' *** CallWindowProc
        WindowProc = CallWindowProc(lpPrevWindowProc, hwnd, uMsg, wParam, lParam)
    End Select
    
    ' *** Disable ErrorHandler
    On Error GoTo 0
End Function
